<template>
    <v-container>
        <h2 class="secondary--text" align="center"> 
            Classificació </h2>
        
        <div class="mt-2">
      <v-alert dark color="primary" elevation="12" border="left" dismissible colored-border>
        <p class=text-justify>Les puntuacions no estan validades, per tant, el recompte de punts és simplement aproximat 
          i provisional. </p>
      </v-alert>
    </div>

    <!-- <v-row class="mt-2"  v-for="team in teams" :key="team.id"></v-row> -->

    <v-col class="mt-3">
      <v-data-table
        :headers="headers"
        :items="teams"
        class="elevation-5"
        mobile-breakpoint="20"
        disable-pagination
        hide-default-footer
        dark
        :single-expand="singleExpand"
        :expanded.sync="expanded"
        item-key="username"
        show-expand
      >
       <template v-slot:item.position="{ item }"> 
          <tbody>
          <tr
          >
            <td>
                <v-icon 
                  :color="getColor(item.position)"
                  :x-small="getSize(item.position)"
                  :right="getSize(item.position)"
                >
                {{ item.position }}

                {{ getMdi(item.position) }}

                </v-icon>
                
            </td>
          </tr>
        </tbody>
      </template>

       <template v-slot:expanded-item="{ headers, item }">
      <td :colspan="headers.length">
        <h4 class="mt-3"> - Participants: </h4> 
        <p class="mt-2"> {{ item.players }} </p>
        <h4 class="mt-3">- Proves completades: </h4>
        <!-- <p v-for="(completed, index) in item.completed" :key="index">
          {{completed.name}}
        </p> -->
        <p class="text-justify mt-2"> {{ item.completed.map((c)=>c.name).join(", ").replace(/, ([^,]*)$/, ' i $1')}} </p>
      </td>
    </template>

      </v-data-table> 
    </v-col>


    <div class="mt-3" align="left">
      <app-ui-back-btn></app-ui-back-btn>
    </div>
    
    </v-container>
</template>

<script>

export default {
  middleware: "auth",
    data() {
        return {
          headers: [
          { text: '', value: 'position', class:'green black--text' },
          { text: 'Equip', value: 'username', class:'green black--text' },
          { text: 'Punts', value: 'score', class:'green black--text' }, 
          { text: '', value: 'data-table-expand', class:'green black--text' },
        ],
        expanded: [],
        singleExpand: true,
        }
    },
  computed:{
    teams(){
      var items = this.$store.getters.readTeams 

      var items = items.filter(function(item) {
          return item.username !== 'admin'; 
            });
       var items = items.filter(function(item) {
          return item.username !== 'Extra1'; 
            });
      var items = items.filter(function(item) {
          return item.username !== 'Extra2'; 
            });
      var items = items.filter(function(item) {
          return item.username !== 'Extra3'; 
            });
      var items = items.filter(function(item) {
          return item.username !== 'Extra4'; 
            });
      var items = items.filter(function(item) {
          return item.username !== 'Extra5'; 
            });
      var items = items.filter(function(item) {
          return item.username !== 'Extra6'; 
            });
      var items = items.filter(function(item) {
          return item.username !== 'Extra7'; 
            });


      items.sort(function (a, b){
        return (b.score - a.score)})
      
      for(let i = 0; i < items.length ; i++){
        const element = items[i]
        element.position = i+1
      }

      return items
    }
  },
  methods: {
      getColor (position) {
        if (position == 1) return 'yellow'
        else if (position == 2) return 'grey lighten-1'
        else if (position == 3) return 'orange accent-2'
      },
      getSize (position) {
        if (position == 1) return false
        else if (position == 2) return false
        else if (position == 3) return false
        else return true
      },
      getMdi (position){
        if (position == 1) return 'mdi-shield-crown'
        else if (position == 2) return 'mdi-numeric-2-circle'
        else if (position == 3) return 'mdi-numeric-3-circle'
      }
    },
  async mounted(){
      await this.$store.dispatch("refreshTeams")
    }
}
</script>

<style scoped>

.container {
  background-image: url("https://i.ibb.co/5MTKvcz/Fons-Sense-Muntanya.png");
  background-size: cover;
  background-position: center;
  height: 100%;
}


  
</style>